#ifndef MONITOR_H
#define MONITOR_H

#include <QMainWindow>
#include <QPainter>
#include <string>
#include "parse.h"
#include "mypraser.h"
#include "ConnectionManager.h"
#define TEAM_Right true
#define TEAM_Left  false
namespace Ui {
class Monitor;
}

class Monitor : public QMainWindow
{
    Q_OBJECT

public:
    explicit Monitor(QWidget *parent = 0);
    ~Monitor();

    void paintEvent(QPaintEvent *event);
    void drawLeft (QPainter& ,QPointF, double, int);
    void drawRight (QPainter&,QPointF, double, int );

    void drawLeftF (QPainter& ,QPointF, double, int);
    void drawRightF (QPainter&,QPointF, double, int );

    void drawBall ( QPainter&,QPointF);
    void drawGoal(QPainter &paint);
    void drawField ( QPainter &paint ) ;
    void parseThing(string );
    void drawObjects ( QPainter &paint, vector <nao> temp ) ;
    void drawOtherLines(QPainter &paint);
    void updateAll();
    void keyPressEvent(QKeyEvent *);
    void playOn();
    void kickOffRight();
    void kickOffLeft();
    void dropBall();
    void dropPlayer(int player);

private:

    int playerNo;
    double fieldLength;
    double fieldWidth;
    double borderField;
    double goalWidth;
    double penaltyWidth;
    double penaltyLength;
    double monitorWidth;
    double monitorLength;
    double borderSize;
    double goalDepth;
    double centerRadius;
    QPointF center;
    double scaleX,scaleY;
    QPointF scale(QPointF);
    QPointF invertScale(QPointF);


    Ui::Monitor *ui;
    parser parse ;
    string t1 , t2 , mode [16] , cmode ;
    int p1 , p2 ;
    double cycle ;
    ConnectionManager sock;
    bool m_con ;
    bool toggle ;
public slots:
    void on_Connect_clicked();
    void on_help_clicked();
    void resize();
};



#endif // MONITOR_H
