#include <iostream>
#include <string>
#include <cstring>
#include <cstdio>
#include <simspark/salt/salt.h>
#include <simspark/salt/vector.h>
#include <sstream>
#include <stack>
#include <vector>
#include <queue>
#include "mypraser.h"
using namespace std;
using namespace salt;

struct node {
    Vector3f pos;
    string name;
    bool visit;
    node* next;
    node* child;
    int depht;
    int id;
    node():pos(0,0,0) {
        next=child=NULL;
        depht=0;

    }
    node(Vector3f p):pos(p) {
        next=child=NULL;
        depht=0;
    }
    void addChild(node* ch) {
        ch->depht=depht+1;
        if(child==NULL)
            child=ch;
        else
        {
            node* cur=child;
            while(cur->next!=NULL)
                cur=cur->next;
            cur->next=ch;
        }
    }
};

class parser {
    Vector3f BallPos;
    vector<string> HeadNames;
    vector<int> HeadIDs;
    vector<int> NodeIndex;
    vector<nao> Player;
    vector<string > Tokens;
    int BallId;
    string BallName;
    int I;
public:
    Vector3f getBallPos() {
        return BallPos;
    }
    parser() {
        I=0;
        end=false;
    }
    string NAMES(int i) {

        stringstream ss;
        ss<<"nd"<<i;
        return ss.str();

    }
    stack<int > path;
    stack<string> pathName;
    bool end;
    void dfs(node* n,string str) {

        if(n->name==str)
        {
            end=true;
            return ;
        }

        int i=0;
        node* cur=n->child;
        while(cur!=NULL && !end)
        {
            path.push(i);
            pathName.push(cur->name);
            dfs(cur,str);
            if(!end) {
                path.pop();
                pathName.pop();
            }

            cur=cur->next;
            i++;
        }
    }
    void dfs(node* n,int id) {

        if(n->id==id)
        {
            end=true;
            return ;
        }
        int i=0;
        node* cur=n->child;
        while(cur!=NULL && !end)
        {
            path.push(i);
            pathName.push(cur->name);
            dfs(cur,id);
            if(!end) {
                path.pop();
                pathName.pop();
            }

            cur=cur->next;
            i++;
        }
    }
    void dfs(node* n) {
        cout<<n->name<<" {";
        node* cur=n->child;
        while(cur!=NULL)
        {
            dfs(cur);
            cur=cur->next;
        }
        cout<<"}";
    }
    void bfs(node* n) {
        queue<node*> q;
        q.push(n);
        while(!q.empty())
        {
            node* nd=q.front();
            q.pop();
            cout<<nd->name;
            node* ch=nd->child;
            while(ch!=NULL)
            {
                q.push(ch);
                ch=ch->next;
            }
        }
    }
    void process(stringstream& ss ,node* nd,string str) {
        string token;
        int c=1;
        while(ss>>token)
        {
            //Tokens.push_back(token);
            if(token=="(")
                c++;
            if(token==")")
                c--;
            if(token=="nd")
            {
                c--;
                node* ch=new node;
                ch->name=NAMES(I);
                ch->id=I;
                I++;
                //cout<<ch->name<<" ";
                nd->addChild(ch);
                //cout<<token<<endl;
                process(ss,ch,str);
            }
            if(token==str)
            {
                HeadNames.push_back(nd->name);
                HeadIDs.push_back(nd->id);

            }
            if(c==0)
                return;

        }

    }
    void process(stringstream& ss ,node* nd,string str1,string str2) {
        string token;
        int c=1;
        while(ss>>token)
        {
            //Tokens.push_back(token);
            if(token=="(")
                c++;
            if(token==")")
                c--;
            if(token=="nd")
            {
                c--;
                node* ch=new node;
                ch->name=NAMES(I);
                ch->id=I;
                I++;
                //cout<<ch->name<<" ";
                nd->addChild(ch);
                //cout<<token<<endl;
                process(ss,ch,str1,str2);
            }
            if(token==str1)
            {
                HeadNames.push_back(nd->name);
                HeadIDs.push_back(nd->id);

            }
            if(token==str2)
            {
                BallName=nd->name;
                BallId=nd->id;
            }
            if(c==0)
                return;

        }
    }
    void replaceAll(string& str,string find ,string replace) {
        size_t start,end=0,findsize=find.size();
        while((start=str.find(find,end))!=string::npos)
        {
            //cout<<start<<endl;
            end=start+replace.size();
            str.replace(start,findsize,replace);
            //cout<<end<<endl;

        }

    }
    Vector3f nextSLT(stringstream& ss) {
        double x=0;
        double y=0;
        double z=0;
        double t=0;

        for(int i=0; i<16; i++)
        {
            switch(i) {
            case 14:
                ss>>z;
                break;
            case 13:
                ss>>y;
                break;
            case 12 :
                ss>>x;
                break;
            default:
                ss>>t;
            }
            //cout<<endl;

        }

        return Vector3f(x,y,z);

    }
    Vector3f nextSLT(int index,vector<string> T) {
        stringstream ss;
        for(int i=1; i<=16; i++)
            ss<<T[index+i]<<" ";
        return nextSLT(ss);
    }
    Vector3f nextSLTRot(int index,vector<string> T) {
        stringstream ss;
        for(int i=1; i<=16; i++)
            ss<<T[index+i]<<" ";
        mypraser p;
        Vector3f pos ;
        Vector3f rot ;
        p.nextSLt(ss , pos , rot );
        return rot;
    }
    void replaceAll(string& str,const char* find ,const char* replace) {
        replaceAll(str,string(find),string(replace));
    }
    void parseString(string /*str*/,stringstream& ss ) {
        string token;
        int c=0;
        while(ss>>token)
        {
            if(token=="(")
                c++;
            if(token==")")
                c--;
        }
    }

    void parseFirstNao(int index,int num) {
        for(unsigned int i=index ; i<Tokens.size(); i++)
        {
            if(Tokens[i].substr(0,Tokens[i].size()-1)=="matNum")
            {
                Player[num].num=Tokens[i][Tokens[i].size()-1]-'0';
                if(Tokens[i+1]=="matLeft")
                    Player[num].team=1;
                else if(Tokens[i+1]=="matRight")
                    Player[num].team=2;
                return;

            }
        }

    }

    void parsePositionNao(int index,nao& Nao) {
        for(unsigned int i=index ; i<Tokens.size(); i++)
        {
            if(Tokens[i]=="SLT") {
                Nao.pos=nextSLT(i,Tokens);
                Nao.rot=nextSLTRot(i,Tokens);
            }
            if(Tokens[i]==")")
                return ;
        }
    }

    void parsePositionBall(int index)
    {
        for(unsigned int i=index ; i<Tokens.size(); i++)
        {
            if(Tokens[i]=="SLT")
                BallPos=nextSLT(i,Tokens);
            if(Tokens[i]==")")
                return ;
        }

    }
    vector<nao> parse(string str) {
        bool rsg=0;
        int l=0;
        string token;
        node* BaseNode=new node;
        BaseNode->name="Base";
        l++;
        stringstream ss,ss2;
        string s=str;
        replaceAll(s,")"," ) ");
        replaceAll(s,"("," ( ");
        ss<<s;
        ss2<<s;
        int cc=0;
        Tokens.clear();
        NodeIndex.clear();
        while(ss2>>token) {
            Tokens.push_back(token);
            cc++;
            if(token=="nd")
                NodeIndex.push_back(cc);
        }
        rsg=false;
        while(ss>>token) {
            if(token=="RSG") {
                rsg=true;
                Player.clear();
                I=0;
                break;
            }
            else if(token=="RDS")
                break;
        };
        //for rsg or rds 0 1 ) (
        ss>>token;
        ss>>token;
        ss>>token;
        ss>>token;

        if(rsg)
        {
            HeadIDs.clear();
            HeadNames.clear();
            process(ss,BaseNode,"models/naobody.obj","models/soccerball.obj");
            for(unsigned  int i=0; i<HeadIDs.size(); i++)
            {
                nao temp;
                Player.push_back(temp);
                parseFirstNao(NodeIndex[HeadIDs[i]],i);
            }

        }

        for(unsigned int i=0; i<HeadIDs.size(); i++)
        {
            parsePositionNao(NodeIndex[HeadIDs[i]-2],Player[i]);


        }
        parsePositionBall(NodeIndex[BallId-1]);
        return Player;


    }
};
